10 '**********************************************************************
20 '*  Program     : ADBLOCK.BAS                                         *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion on a block of channels with interrupt    *
50 '*                data transfer.                                      *
60 '*  Revision    : 1.00                                                *
70 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
80 '**********************************************************************
90 '
100 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
110 CLEAR, 49152!
120 DEF SEG = 0
130 SG = 256 * PEEK(&H511) + PEEK(&H510)
140 SG = SG + 49152!/16
150 DEF SEG = SG
160 BLOAD "3718BAS.BIN", 0
170 PCM3718 = 0                    ' Driver entry point
180 '
190 DIM PARAM%(60)                 ' If two boards installed, need to declare
200                                ' the second parameter array
210 DIM DAT%(100)                  ' Conversion data buffer
220 '
230 PARAM%(0) = 0                  ' Board number
240 PARAM%(1) = &H300              ' Base I/O address
250 PARAM%(4) = 2                  ' IRQ level : IRQ2
260 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
270 PARAM%(6) = 100                '
280 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
290 PARAM%(8) = 0                  ' Non-cyclic
300 PARAM%(10) = 0                 ' Offset of A/D data buffer A
310 PARAM%(11) = &H7000            ' Segment of A/D data buffer A
320 PARAM%(12) = 0                 ' Data buffer B address, if not used,
330 PARAM%(13) = 0                 ' must set to 0.
340 '
350 ' If your BASICA does not support VARSEG() function, you can put 0
360 ' to PARAM%(11), it means to use current data segment.
370 ' If you want to use the absolute memory address, please follow the steps.
380 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
390 ' PARAM%(11) = &H7000
400 ' DEF SEG = &H7000             ' Define segment
410 ' After data conversion finished then use PEEK function to transfer data.
420 '
430 PARAM%(14) = 50                ' A/D conversion number
440 PARAM%(15) = 0                 ' A/D conversion block scan start channel
450 PARAM%(16) = 7                 ' A/D conversion block scan stop channel
460 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
470 ' PARAM%(45) : Error Code
480 ' PARAM%(46) : Return Value 0
490 ' PARAM%(47) : Return Value 1
500 '
510 FUN% = 3                       ' FUNCTION 3
520 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
530 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
540 '
550 FUN% = 100                     ' FUNCTION 100
560 CALL PCM3718(FUN%, PARAM%(0))  ' Func 100 : A/D initialization
570 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !":STOP
580 '
590 ' Block channel scan function 100 is very similar to function 9.
600 ' The only difference is block channel scan function 100 scans
610 ' all input channels (specified by PARAM%(15) and PARAM%(16))
620 ' on each trigger pulse, and the function 9 scans one channel
630 ' on each trigger pulse.
640 '
650 FUN% = 105                     ' FUNCTION 105
660 CALL PCM3718(FUN%, PARAM%(0))  ' Func 105  : Pacer trigger A/D conversion
670                                '             with interrupt data transfer
680 IF PARAM%(45) <> 0 THEN PRINT "A/D INTERRUPT BLOCK DATA TRANSFER FAILED !":STOP
690 '
700 FUN% = 106                     ' FUNCTION 106
710 CALL PCM3718(FUN%, PARAM%(0))  ' Func 106: Check interrupt status
720 CHK% = (PARAM%(46) AND 1)
730 IF CHK% <> 0 THEN GOTO 700     ' 0 : Not active, 1 : Active
740 DEF SEG = &H7000
750 FOR I = 0 TO 50
760 DAT%(I) = PEEK(I * 2) + (PEEK(I * 2 + 1) AND &HF) * 256
770 NEXT I
780 FOR I = 0 TO PARAM%(14) - 1    ' Display data
790 PRINT USING "DATA[ ### ] = ##.## V "; I, (10 * DAT%(I) / 4096 + (-5))
800 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
810 ' DAT%(I) : A/D input data
820 ' 4096    : Full scale 12 bit A/D data
830 ' (-5)    : A/D input range "-5" V
840 NEXT I
850 END
