10  '**********************************************************************
20  '*  Program     : ADDMA.BAS                                           *
30  '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40  '*                conversion with DMA data transfer.                  *
50  '*  Revision    : 1.00                                                *
60  '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70  '**********************************************************************
80  '
90  SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
100 CLEAR, 49152!
110 DEF SEG = 0
120 SG = 256 * PEEK(&H511) + PEEK(&H510)
130 SG = SG + 49152!/16
140 DEF SEG = SG
150 BLOAD "3718BAS.BIN", 0
160 PCM3718 = 0                    ' Driver segment offset
170 '
180 DIM PARAM%(60)                 ' If two boards installed, need to declare
190                                ' the second parameter array
200 DIM DAT!(100)                  ' Coversion data buffer
210 '
220 PARAM%(0) = 0                  ' Board number
230 PARAM%(1) = &H300              ' Base I/O address
240 PARAM%(2) = 3                  ' Buffer A DMA channel
250 PARAM%(4) = 2                  ' IRQ level : IRQ2
260 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
270 PARAM%(6) = 100                '
280 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
290 PARAM%(8) = 0                  ' Non-cyclic
300 PARAM%(10) = 0                 ' Offset of A/D data buffer A
310 PARAM%(11) = &H7000            ' Segment of A/D data buffer A
320 PARAM%(12) = 0                 ' Data buffer B address; if not used,
330 PARAM%(13) = 0                 ' must set to 0.
340 ' If your BASICA does not support VARSEG() function, you can put 0
350 ' to PARAM%(11) = 0. It means to use current data segment.
360 ' If you want to the use absolute memory address, please follow the steps.
370 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
380 ' PARAM%(11) = &H7000
390 ' DEF SEG = &H7000             ' Define segment
400 ' After data conversion finished then use PEEK function to transfer data.
410 '
420 PARAM%(14) = 50                ' A/D conversion number
430 PARAM%(15) = 0                 ' A/D conversion start channel
440 PARAM%(16) = 0                 ' A/D conversion stop channel
450 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
460 ' PARAM%(45) : Error Code
470 ' PARAM%(46) : Return Value 0
480 ' PARAM%(47) : Return Value 1
490 '
500 FUN% = 3                       ' FUNCTION 3
510 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
520 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
530 '
540 FUN% = 4                       ' FUNCTION 4
550 CALL PCM3718(FUN%, PARAM%(0))  ' Func 4 : A/D initialization
560 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !":STOP
570 '
580 FUN% = 6                       ' FUNCTION 6
590 CALL PCM3718(FUN%, PARAM%(0))  ' Func 6 : Pacer trigger A/D conversion
600                                '          with DMA data transfer
610 IF PARAM%(45) <> 0 THEN PRINT "A/D DMA DATA TRANSFER FAILED !":STOP
620 '
630 FUN% = 7                       ' FUNCTION 7
640 CALL PCM3718(FUN%, PARAM%(0))  ' Func 7 : Check DMA operation status
650 CHK% = (PARAM%(46) AND 1)
660 IF CHK% <> 0 THEN GOTO 630     ' 0 : Not active, 1 : Active
670 DEF SEG = &H7000
680 FOR I = 0 TO 50
690 DAT!(I) = PEEK(I * 2) + PEEK(I * 2 + 1) * 256
700 NEXT I
710 FOR I = 0 TO PARAM%(14)-1      ' Display data
720 PRINT USING "DATA[ ### ] = ##.## V "; I ,(10*(DAT!(I)/16)/4096+(-5))
730 ' Because of the data format, shift right 4 bits to get real value.
740 ' The data in low nybble is A/D channel number from which this data converted.
750 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
760 ' DAT!(I) : A/D input data
770 ' 4096    : Full scale 12 bit A/D data
780 ' (-5)    : A/D input range "-5" V
790 NEXT I
800 END
