10 '**********************************************************************
20 '*  Program     : ADINT.BAS                                           *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion with interrupt data transfer.            *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 '
90 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
100 CLEAR, 49152!
110 DEF SEG = 0
120 SG = 256 * PEEK(&H511) + PEEK(&H510)
130 SG = SG + 49152!/16
140 DEF SEG = SG
150 BLOAD "3718BAS.BIN", 0
160 PCM3718 = 0                    ' Driver entry point
170 '
180 DIM PARAM%(60)                 ' If two boards installed, need to declare
190                                ' the second parameter array
200 DIM DAT%(100)                  ' Conversion data buffer
210 '
220 PARAM%(0) = 0                  ' Board number
230 PARAM%(1) = &H300              ' Base I/O address
240 PARAM%(4) = 2                  ' IRQ level : IRQ2
250 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
260 PARAM%(6) = 100                '
270 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
280 PARAM%(8) = 0                  ' Non-cyclic
290 PARAM%(10) = 0                 ' Offset of A/D data buffer A
300 PARAM%(11) = &H7000            ' Segment of A/D data buffer A
310 PARAM%(12) = 0                 ' Data buffer B address, if not used,
320 PARAM%(13) = 0                 ' must set to 0.
330 '
340 ' If your BASICA does not support VARSEG() function, you can put 0
350 ' to PARAM%(11), it means to use current data segment.
360 ' If you want to use the absolute memory address, please follow the steps.
370 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
380 ' PARAM%(11) = &H7000
390 ' DEF SEG = &H7000             ' Define segment
400 ' After data conversion finished then use PEEK function to transfer data.
410 '
420 PARAM%(14) = 50                ' A/D conversion number
430 PARAM%(15) = 0                 ' A/D conversion start channel
440 PARAM%(16) = 0                 ' A/D conversion stop channel
450 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
460 ' PARAM%(45) : Error Code
470 ' PARAM%(46) : Return Value 0
480 ' PARAM%(47) : Return Value 1
490 '
500 FUN% = 3                       ' FUNCTION 3
510 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
520 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
530 '
540 FUN% = 4                       ' FUNCTION 4
550 CALL PCM3718(FUN%, PARAM%(0))  ' Func 4 : A/D initialization
560 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !":STOP
570 '
580 FUN% = 9                       ' FUNCTION 9
590 CALL PCM3718(FUN%, PARAM%(0))  ' Func 9 : Pacer trigger A/D conversion
600                                '          with interrupt data transfer
610 IF PARAM%(45) <> 0 THEN PRINT "A/D INTERRUPT DATA TRANSFER FAILED !":STOP
620 '
630 FUN% = 10                      ' FUNCTION 10
640 CALL PCM3718(FUN%, PARAM%(0))  ' Func 10: Check interrupt status
650 CHK% = (PARAM%(46) AND 1)
660 IF CHK% <> 0 THEN GOTO 630     ' 0 : Not active, 1 : Active
670 DEF SEG = &H7000
680 FOR I = 0 TO 50
690 DAT%(I) = PEEK(I * 2) + (PEEK(I * 2 + 1) AND &HF) * 256
700 NEXT I
710 FOR I = 0 TO PARAM%(14) - 1    ' Display data
720 PRINT USING "DATA[ ### ] = ##.## V "; I, (10 * DAT%(I) / 4096 + (-5))
730 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
740 ' DAT%(I) : A/D input data
750 ' 4096    : Full scale 12 bit A/D data
760 ' (-5)    : A/D input range "-5" V
770 NEXT I
780 END
