10 '**********************************************************************
20 '*  Program     : ADTHERM.BAS                                         *
30 '*  Description : Demo program for PCLD-779 to use PCM-3718 pacer     *
40 '*                trigger A/D conversion with software data transfer. *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 '
90 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
100 CLEAR, 49152!
110 DEF SEG = 0
120 SG = 256 * PEEK(&H511) + PEEK(&H510)
130 SG = SG + 49152!/16
140 DEF SEG = SG
150 BLOAD "3718BAS.BIN", 0
160 PCM3718 = 0			   ' Driver entry point
170 '
180 DIM PARAM%(60)		   ' If two boards installed, need to declare
190				   ' the second parameter array
200 DIM DAT%(100)		   ' Conversion PCLD-779 A/D data buffer
210 DIM CJC%(100)		   ' Conversion PCLD-779 CJC data buffer
220 '
230 PARAM%(0) = 0		   ' Board number
240 PARAM%(1) = &H300		   ' Base I/O address
250 PARAM%(5) = 1000		   ' Pacer rate = 1M / (1000 * 200) = 5 Hz
260 PARAM%(6) = 200		   '
270 PARAM%(10) = 0		   ' Offset of PCLD-779 A/D data buffer A
280 PARAM%(11) = &H7000 	   ' Segment of PCLD-779 A/D data buffer A
290 PARAM%(12) = 0		   ' Data buffer B address, if not used,
300 PARAM%(13) = 0		   ' must set to 0.
310 '
320 ' If your BASICA does not support VARSEG() function, you can put 0
330 ' to PARAM%(11), it means to use current data segment.
340 ' If you want to use the absolute memory address, please follow the steps.
350 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
360 ' PARAM%(11) = &H7000
370 ' DEF SEG = &H7000             ' Define segment
380 ' After data conversion finished then use PEEK function to transfer data.
390 '
400 PARAM%(14) = 20		   ' PCLD-779 A/D conversion number
410 PARAM%(15) = 0		   ' PCLD-779 conversion start channel
420 PARAM%(16) = 0		   ' PCLD-779 conversion stop channel
430 PARAM%(17) = 0		   ' PCM-3718's overall gain code, 0 : +/- 5V
440 ' PARAM%(45) : Error Code
450 ' PARAM%(46) : Return Value 0
460 ' PARAM%(47) : Return Value 1
470 PARAM%(50) = 1		   ' 1 : PCLD-779 daughter board type
480 PARAM%(51) = 0		   ' 0 : SoftWare, 2 : Interrupt trigger
490 PARAM%(52) = 0		   ' Offset of PCLD-779 CJC data buffer
500 PARAM%(53) = &H6000 	   ' Segment of PCLD-779 CJC data buffer
510 '
520 FUN% = 3			   ' FUNCTION 3
530 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
540 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
550 '
560 PRINT "Please Wait......."
570 FUN% = 96			   ' FUNCTION 96
580 CALL PCM3718(FUN%, PARAM%(0))  ' Func 96 : A/D initialization
590 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !":STOP
600 '
610 FUN% = 97			   ' FUNCTION 97
620 CALL PCM3718(FUN%, PARAM%(0))  ' Func 97 : "N" times of A/D trigger
630				   '
640 IF PARAM%(45) <> 0 THEN PRINT "A/D SOFTWARE DATA TRANSFER FAILED !":STOP
650 '
660 DEF SEG = &H7000
670 FOR I = 0 TO 50
680 DAT%(I) = PEEK(I * 2) + (PEEK(I * 2 + 1) AND &HF) * 256
690 NEXT I
700 DEF SEG = &H6000
710 FOR I = 0 TO 50
720 CJC%(I) = PEEK(I * 2) + (PEEK(I * 2 + 1) AND &HF) * 256
730 NEXT I
740 FOR I = 0 TO PARAM%(14) - 1    ' Display data
750 PRINT USING "DATA[ ### ] = ##.## V "; I, (10 * DAT%(I) / 4096 + (-5));
760 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
770 ' DAT%(I) : A/D input data
780 ' 4096    : Full scale 12 bit A/D data
790 ' (-5)    : A/D input range "-5" V
800 PRINT USING "   CJC ###.## C";(10 * CJC%(0) / 4096 + (-5)) * 1000/24.4
810 NEXT I
820 END
