10 '***********************************************************************
20 '*  Program     : ADTRIG.BAS                                           *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D          *
40 '*                conversion with software data transfer.              *
50 '*  Revision    : 1.00                                                 *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd     *
70 '***********************************************************************
80 '
90 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
100 CLEAR, 49152!
110 DEF SEG = 0
120 SG = 256 * PEEK(&H511) + PEEK(&H510)
130 SG = SG + 49152!/16
140 DEF SEG = SG
150 BLOAD "3718BAS.BIN", 0
160 PCM3718 = 0                    ' Driver entry point
170 '
180 DIM PARAM%(60)                 ' If two boards installed, need to declare
190                                ' the second parameter array
200 DIM DAT%(100)                  ' Conversion data buffer
210 '
220 PARAM%(0) = 0                  ' Board number
230 PARAM%(1) = &H300              ' Base I/O address
240 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
250 PARAM%(6) = 100                '
260 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
270 PARAM%(10) = 0                 ' Offset of A/D data buffer A
280 PARAM%(11) = &H7000            ' Segment of A/D data buffer A
290 PARAM%(12) = 0                 ' Data buffer B address, if not used,
300 PARAM%(13) = 0                 ' must set to 0.
310 '
320 ' If your BASICA does not support VARSEG() function, you can put 0
330 ' to PARAM%(11), it means to use current data segment.
340 ' If you want to use the absolute memory address, please follow the steps.
350 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
360 ' PARAM%(11) = &H7000
370 ' DEF SEG = &H7000             ' Define segment
380 ' After data conversion finished then use PEEK function to transfer data.
390 '
400 PARAM%(14) = 50                ' A/D conversion number
410 PARAM%(15) = 0                 ' A/D conversion start channel
420 PARAM%(16) = 0                 ' A/D conversion stop channel
430 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
440 ' PARAM%(45) : Error Code
450 ' PARAM%(46) : Return Value 0
460 ' PARAM%(47) : Return Value 1
470 '
480 FUN% = 3                       ' FUNCTION 3
490 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
500 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
510 '
520 FUN% = 4                       ' FUNCTION 4
530 CALL PCM3718(FUN%, PARAM%(0))  ' Func 4 : A/D initialization
540 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !":STOP
550 '
560 FUN% = 5                       ' FUNCTION 5
570 CALL PCM3718(FUN%, PARAM%(0))  ' Func 5 : "N" times of A/D trigger
580 IF PARAM%(45) <> 0 THEN PRINT "A/D SOFTWARE DATA TRANSFER FAILED !":STOP
590 '
600 DEF SEG = &H7000
610 FOR I = 0 TO 50
620 DAT%(I) = PEEK(I * 2) + (PEEK(I * 2 + 1) AND &HF) * 256
630 NEXT I
640 FOR I = 0 TO PARAM%(14) - 1    ' Display data
650 PRINT USING "DATA[ ### ] = ##.## V "; I, (10 * DAT%(I) / 4096 + (-5))
660 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
670 ' DAT%(I) : A/D input data
680 ' 4096    : Full scale 12 bit A/D data
690 ' (-5)    : A/D input range "-5" V
700 NEXT I
710 END
