10 '**********************************************************************
20 '*  Program     : DIGIN.BAS                                           *
30 '*  Description : Demo program for PCM-3718 digital input             *
40 '*  Revision    : 1.00                                                *
50 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
60 '**********************************************************************
70 '
80 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
90 CLEAR, 49152!
100 DEF SEG = 0
110 SG = 256 * PEEK(&H511) + PEEK(&H510)
120 SG = SG + 49152!/16
130 DEF SEG = SG
140 BLOAD "3718BAS.BIN", 0
150 PCM3718 = 0                    ' Driver entry point
160 '
170 DIM PARAM%(60)                 ' If two boards installed, need to declare
180                                ' the second parameter array
190 DIM DAT%(100)                  ' Digital input data buffer
200 '
210 PARAM%(0) = 0                  ' Board number
220 PARAM%(1) = &H300              ' Base I/O address
230 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
240 PARAM%(6) = 100                '
250 PARAM%(27) = 0                 ' Offset of digital input data buffer A
260 PARAM%(28) = &H7000            ' Segment of digital input data buffer A
270 PARAM%(29) = 0                 ' Data buffer B address, if not used,
280 PARAM%(30) = 0                 ' must set to 0.
290 '
300 ' If your BASICA does not support VARSEG() function, you can put 0
310 ' to PARAM%(28), it means to use current data segment.
320 ' If you want to use the absolute memory address, please follow the steps.
330 ' PARAM%(27) = 0               ' Make sure 7000:0 is empty.
340 ' PARAM%(28) = &H7000
350 ' DEF SEG = &H7000             ' Define segment
360 ' After data conversion finished then use PEEK function to transfer data.
370 '
380 PARAM%(31) = 50                ' Digital input number
390 PARAM%(32) = 0                 ' Digital input port
400 ' PARAM%(45) : Error Code
410 ' PARAM%(46) : Return Value 0
420 ' PARAM%(47) : Return Value 1
430 '
440 FUN% = 3                       ' FUNCTION 3
450 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
460 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
470 '
480 FUN% = 20                      ' FUNCTION 20
490 CALL PCM3718(FUN%, PARAM%(0))  ' Func 20 : Digital input initialization
500 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL INPUT INITIALIZATION FAILED !":STOP
510 '
520 FUN% = 21                      ' FUNCTION 21
530 CALL PCM3718(FUN%, PARAM%(0))  ' Func 21 : "N" times of Digital input
540 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL INPUT FAILED !":STOP
550 '
560 DEF SEG = &H7000
570 FOR I = 0 TO 50
580 DAT%(I) = PEEK(I)
590 NEXT I
600 FOR I = 0 TO PARAM%(31) - 1  ' Display data
610 PRINT "DATA[" I "] = "; DAT%(I),
620 NEXT I
630 END
