10 '**********************************************************************
20 '*  Program     : DIGOUT.BAS                                          *
30 '*  Description : Demo program for PCM-3718 digital output            *
40 '*  Revision    : 1.00                                                *
50 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
60 '**********************************************************************
70 '
80 SCREEN 0,0,0:WIDTH 80:CLS:KEY OFF
90 CLEAR, 49152!
100 DEF SEG = 0
110 SG = 256 * PEEK(&H511) + PEEK(&H510)
120 SG = SG + 49152!/16
130 DEF SEG = SG
140 BLOAD "3718BAS.BIN", 0
150 PCM3718 = 0                    ' Driver entry point
160 '
170 DIM PARAM%(60)                 ' If two boards installed, need to declare
180                                ' the second parameter array
190 DIM DAT%(100)                  ' Digital output data buffer
200 '
210 PARAM%(0) = 0                  ' Board number
220 PARAM%(1) = &H300              ' Base I/O address
230 PARAM%(33) = 0                 ' Offset of digital output data buffer A
240 PARAM%(34) = &H7000            ' Segment of digital output data buffer A
250 PARAM%(35) = 0                 ' Data buffer B address, if not used,
260 PARAM%(36) = 0                 ' must set to 0.
270 '
280 ' If your BASICA does not support VARSEG() function, you can put 0
290 ' to PARAM%(34), it means to use current data segment.
300 ' If you want to use the absolute memory address, please follow the steps.
310 ' PARAM%(33) = 0               ' Make sure 7000:0 is empty.
320 ' PARAM%(34) = &H7000
330 ' DEF SEG = &H7000             ' Define segment
340 '
350 PARAM%(37) = 1                 ' Digital output number
360 PARAM%(38) = 0                 ' Digital output port
370 ' PARAM%(45) : Error Code
380 ' PARAM%(46) : Return Value 0
390 ' PARAM%(47) : Return Value 1
400 '
410 FUN% = 3                       ' FUNCTION 3
420 CALL PCM3718(FUN%, PARAM%(0))  ' Func 3 : Hardware initialization
430 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !":STOP
440 '
450 FUN% = 28                      ' FUNCTION 28
460 CALL PCM3718(FUN%, PARAM%(0))  ' Func 28 : Digital output initialization
470 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL OUTPUT INITIALIZATION FAILED !":STOP
480 '
490 INPUT "ENTER DIGITAL OUTPUT DATA (0-255) : ";DAT%(0)
500 DEF SEG = &H7000
510 POKE 0, DAT%(0) AND &HFF
520 DEF SEG = SG
530 FUN% = 29                      ' FUNCTION 29
540 CALL PCM3718(FUN%, PARAM%(0))  ' Func 29 : "N" times of digital output
550 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL OUTPUT FAILED !":STOP
560 '
570 END
