10 '**********************************************************************
20 '*  Program     : ADBLOCK.BAS                                         *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion on a block of channels with interrupt    *
50 '*                data transfer.                                      *
60 '*  Revision    : 1.00                                                *
70 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
80 '**********************************************************************
90 DIM PARAM%(60)                 ' If two boards installed, need to declare
100                                ' the second parameter array
110 DIM DAT%(100)                  ' Conversion data buffer
120 '
130 PARAM%(0) = 0                  ' Board number
140 PARAM%(1) = &H300              ' Base I/O address
150 PARAM%(4) = 2                  ' IRQ level : IRQ2
160 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
170 PARAM%(6) = 100                '
180 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
190 PARAM%(8) = 0                  ' Non-cyclic
200 PARAM%(10) = VARPTR(DAT%(0))   ' Offset of A/D data buffer A
210 PARAM%(11) = VARSEG(DAT%(0))   ' Segment of A/D data buffer A
220 PARAM%(12) = 0                 ' Data buffer B address, if not used,
230 PARAM%(13) = 0                 ' must set to 0.
240 '
250 ' If your BASICA does not support VARSEG() function, you can put 0
260 ' to PARAM%(11), it means to use current data segment.
270 ' If you want to use the absolute memory address, please follow the steps.
280 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
290 ' PARAM%(11) = &H7000
300 ' DEF SEG = &H7000             ' Define segment
310 ' After data conversion finished then use PEEK function to transfer data.
320 '
330 PARAM%(14) = 50                ' A/D conversion number
340 PARAM%(15) = 0                 ' A/D conversion start channel
350 PARAM%(16) = 7                 ' A/D conversion stop channel
360 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
370 ' PARAM%(45) : Error Code
380 ' PARAM%(46) : Return Value 0
390 ' PARAM%(47) : Return Value 1
400 '
410 FUN% = 3                       ' FUNCTION 3
420 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
430 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
440 '
450 FUN% = 100                     ' FUNCTION 100
460 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 100  : A/D initialization
470 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !": STOP
480 '
490 ' Block channel scan function 100 is very similar to function 9.
500 ' The only difference is block channel scan function 100 scans
510 ' all input channels (specified by PARAM%(15) and PARAM%(16))
520 ' on each trigger pulse, and the function 9 scans one channel
530 ' on each trigger pulse.
540 '
550 FUN% = 105                     ' FUNCTION 105
560 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 105 : Pacer trigger A/D
570                                ' conversion with interrupt data transfer
580 IF PARAM%(45) <> 0 THEN PRINT "A/D INTERRUPT DATA TRANSFER FAILED !": STOP
590 '
600 FUN% = 106                     ' FUNCTION 106
610 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 106: Check interrupt status
620 CHK% = (PARAM%(46) AND 1)
630 IF CHK% <> 0 THEN GOTO 600     ' 0 : Not active, 1 : Active
640 '
650 FOR I = 0 TO PARAM%(14) - 1    ' Display data
660 PRINT USING "DATA[ ### ] = ##.## V "; I, (10! * DAT%(I) / 4096! + (-5!))
670 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
680 ' DAT%(I) : A/D input data
690 ' 4096    : Full scale 12 bit A/D data
700 ' (-5)    : A/D input range "-5" V
710 NEXT I
720 END
