10 '**********************************************************************
20 '*  Program     : ADDMA.BAS                                           *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion with DMA data transfer.                  *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 DIM PARAM%(60)                  ' If two boards installed, need to declare
90                                 ' the second parameter array
100 DIM DAT%(100)                  ' Conversion data buffer
110 '
120 PARAM%(0) = 0                  ' Board number
130 PARAM%(1) = &H300              ' Base I/O address
140 PARAM%(2) = 3                  ' Buffer A DMA channel
150 PARAM%(4) = 2                  ' IRQ level : IRQ2
160 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
170 PARAM%(6) = 100                '
180 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
190 PARAM%(8) = 0                  ' Non-cyclic
200 PARAM%(10) = VARPTR(DAT%(0))   ' Offset of A/D data buffer A
210 PARAM%(11) = VARSEG(DAT%(0))   ' Segment of A/D data buffer A
220 PARAM%(12) = 0                 ' Data buffer B address, if not used,
230 PARAM%(13) = 0                 ' must set to 0.
240 '
250 ' If your BASICA does not support VARSEG() function, you can put 0
260 ' to PARAM%(11), it means to use current data segment.
270 ' If you want to use the absolute memory address, please follow the steps.
280 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
290 ' PARAM%(11) = &H7000
300 ' DEF SEG = &H7000             ' Define segment
310 ' After data conversion finished then use PEEK function to transfer data.
320 '
330 PARAM%(14) = 50                ' A/D conversion number
340 PARAM%(15) = 0                 ' A/D conversion start channel
350 PARAM%(16) = 0                 ' A/D conversion stop channel
360 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
370 ' PARAM%(45) : Error Code
380 ' PARAM%(46) : Return Value 0
390 ' PARAM%(47) : Return Value 1
400 '
410 FUN% = 3                       ' FUNCTION 3
420 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
430 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
440 '
450 FUN% = 4                       ' FUNCTION 4
460 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 4 : A/D initialization
470 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !": STOP
480 '
490 FUN% = 6                       ' FUNCTION 6
500 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 6 : Pacer trigger A/D conversion
510                                '              with DMA data transfer
520 IF PARAM%(45) <> 0 THEN PRINT "A/D DMA DATA TRANSFER FAILED !": STOP
530 '
540 FUN% = 7                       ' FUNCTION 7
550 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 7: Check DMA status
560 CHK% = (PARAM%(46) AND 1)
570 IF CHK% <> 0 THEN GOTO 540     ' 0 : Not active, 1 : Active
580 '
590 FOR I = 0 TO PARAM%(14) - 1    ' Display data
600 PRINT USING "DATA[ ### ] = ##.## V ";I,(10!*(((DAT%(I) AND &HFFF0)/16) AND &H0FFF)/4096!+(-5!))
610 ' Because of the data format, shift right 4 bits to get real value.
620 ' The data in low nybble is A/D channel number from which this data converted.
630 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
640 ' DAT%(I) : A/D input data
650 ' 4096    : Full scale 12 bit A/D data
660 ' (-5)    : A/D input range "-5" V
670 NEXT I
680 END

