10 '**********************************************************************
20 '*  Program     : ADINT.BAS                                           *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion with interrupt data transfer.            *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 DIM PARAM%(60)                 ' If two boards installed, need to declare
90                                ' the second parameter array
100 DIM DAT%(100)                  ' Conversion data buffer
110 '
120 PARAM%(0) = 0                  ' Board number
130 PARAM%(1) = &H300              ' Base I/O address
140 PARAM%(4) = 2                  ' IRQ level : IRQ2
150 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
160 PARAM%(6) = 100                '
170 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
180 PARAM%(8) = 0                  ' Non-cyclic
190 PARAM%(10) = VARPTR(DAT%(0))   ' Offset of A/D data buffer A
200 PARAM%(11) = VARSEG(DAT%(0))   ' Segment of A/D data buffer A
210 PARAM%(12) = 0                 ' Data buffer B address, if not used,
220 PARAM%(13) = 0                 ' must set to 0.
230 '
240 ' If your BASICA does not support VARSEG() function, you can put 0
250 ' to PARAM%(11), it means to use current data segment.
260 ' If you want to use the absolute memory address, please follow the steps.
270 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
280 ' PARAM%(11) = &H7000
290 ' DEF SEG = &H7000             ' Define segment
300 ' After data conversion finished then use PEEK function to transfer data.
310 '
320 PARAM%(14) = 50                ' A/D conversion number
330 PARAM%(15) = 0                 ' A/D conversion start channel
340 PARAM%(16) = 0                 ' A/D conversion stop channel
350 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
360 ' PARAM%(45) : Error Code
370 ' PARAM%(46) : Return Value 0
380 ' PARAM%(47) : Return Value 1
390 '
400 FUN% = 3                       ' FUNCTION 3
410 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
420 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
430 '
440 FUN% = 4                       ' FUNCTION 4
450 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 4 : A/D initialization
460 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !": STOP
470 '
480 FUN% = 9                       ' FUNCTION 9
490 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 9 : Pacer trigger A/D conversion
500                                '              with interrupt data transfer
510 IF PARAM%(45) <> 0 THEN PRINT "A/D INTERRUPT DATA TRANSFER FAILED !": STOP
520 '
530 FUN% = 10                      ' FUNCTION 10
540 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 10: Check interrupt status
550 CHK% = (PARAM%(46) AND 1)
560 IF CHK% <> 0 THEN GOTO 530     ' 0 : Not active, 1 : Active
570 '
580 FOR I = 0 TO PARAM%(14) - 1    ' Display data
590 PRINT USING "DATA[ ### ] = ##.## V "; I, (10! * DAT%(I) / 4096! + (-5!))
600 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
610 ' DAT%(I) : A/D input data
620 ' 4096    : Full scale 12 bit A/D data
630 ' (-5)    : A/D input range "-5" V
640 NEXT I
650 END
