10 '**********************************************************************
20 '*  Program     : ADTHERM.BAS                                         *
30 '*  Description : Demo program for PCLD-779 to use PCM-3718 pacer     *
40 '*                trigger A/D conversion with software data transfer. *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 DIM PARAM%(60)                 ' If two boards installed, need to declare
90                                ' the second parameter array
100 DIM DAT%(100)                  ' Conversion PCLD-779 A/D data buffer
110 DIM CJC%(100)                 ' Conversion PCLD-779 CJC data buffer
120 '
130 PARAM%(0) = 0                  ' Board number
140 PARAM%(1) = &H300              ' Base I/O address
150 PARAM%(5) = 1000               ' Pacer rate = 1M / (1000 * 200) = 5 Hz
160 PARAM%(6) = 200                '
170 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
180 PARAM%(10) = VARPTR(DAT%(0))   ' Offset of PCLD-779 A/D data buffer A
190 PARAM%(11) = VARSEG(DAT%(0))   ' Segment of PCLD-779 A/D data buffer A
200 PARAM%(12) = 0                 ' Data buffer B address, if not used,
210 PARAM%(13) = 0                 ' must set to 0.
220 '
230 ' If your BASICA does not support VARSEG() function, you can put 0
240 ' to PARAM%(11), it means to use current data segment.
250 ' If you want to use the absolute memory address, please follow the steps.
260 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
270 ' PARAM%(11) = &H7000
280 ' DEF SEG = &H7000             ' Define segment
290 ' After data conversion finished then use PEEK function to transfer data.
300 '
310 PARAM%(14) = 20                ' PCLD-779 A/D conversion number
320 PARAM%(15) = 0                 ' PCLD-779 conversion start channel
330 PARAM%(16) = 0                 ' PCLD-779 conversion stop channel
340 PARAM%(17) = 0                 ' PCM-3718's overall gain code, 0 : +/- 5V
350 ' PARAM%(45) : Error Code
360 ' PARAM%(46) : Return Value 0
370 ' PARAM%(47) : Return Value 1
380 '
390 PARAM%(50) = 1                 ' 1 : PCLD-779 daughter board type
400 PARAM%(51) = 0                 ' 0 : SoftWare, 2 : Interrupt trigger
410 PARAM%(52) = VARPTR(CJC%(0))   ' Offset of PCLD-779 CJC data buffer
420 PARAM%(53) = VARSEG(CJC%(0))   ' Segment of PCLD-779 CJC data buffer
430 FUN% = 3                       ' FUNCTION 3
440 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
450 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
460 '
470 FUN% = 96                      ' FUNCTION 96
480 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 96   : A/D initialization
490 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !": STOP
500 '
510 PRINT "Please Wait......"
520 FUN% = 97                        ' FUNCTION 97
530 CALL PCM3718(FUN%, SEG PARAM%(0))  ' Func 97: "N" times of A/D trigger
540                                    '
550 IF PARAM%(45) <> 0 THEN PRINT "A/D SOFTWARE DATA TRANSFER FAILED !": STOP
560 PRINT
570 FOR I = 0 TO PARAM%(14) - 1    ' Display data
580 PRINT USING "DATA[ ### ] = ##.## V "; I, (10! * DAT%(I) / 4096! + (-5!));
590 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
600 ' DAT%(I) : A/D input data
610 ' 4096    : Full scale 12 bit A/D data
620 ' (-5)    : A/D input range "-5" V
630 PRINT USING "   CJC ###.## C";(10 * CJC%(0) / 4096 + (-5)) * 1000/24.4
640 NEXT I
650 END
