10 '**********************************************************************
20 '*  Program     : ADTRIG.BAS                                          *
30 '*  Description : Demo program for PCM-3718 pacer trigger A/D         *
40 '*                conversion with software data transfer.             *
50 '*  Revision    : 1.00                                                *
60 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
70 '**********************************************************************
80 DIM PARAM%(60)                 ' If two boards installed, need to declare
90                                ' the second parameter array
100 DIM DAT%(100)                  ' Conversion data buffer
110 '
120 PARAM%(0) = 0                  ' Board number
130 PARAM%(1) = &H300              ' Base I/O address
140 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
150 PARAM%(6) = 100
160 PARAM%(7) = 0                  ' Trigger mode, 0 : pacer trigger
170 PARAM%(10) = VARPTR(DAT%(0))   ' Offset of A/D data buffer A
180 PARAM%(11) = VARSEG(DAT%(0))   ' Segment of A/D data buffer A
190 PARAM%(12) = 0                 ' Data buffer B address, if not used,
200 PARAM%(13) = 0                 ' must set to 0.
210 '
220 ' If your BASICA does not support VARSEG() function, you can put 0
230 ' to PARAM%(11), it means to use current data segment.
240 ' If you want to use the absolute memory address, please follow the steps.
250 ' PARAM%(10) = 0               ' Make sure 7000:0 is empty.
260 ' PARAM%(11) = &H7000
270 ' DEF SEG = &H7000             ' Define segment
280 ' After data conversion finished then use PEEK function to transfer data.
290 '
300 PARAM%(14) = 50                ' A/D conversion number
310 PARAM%(15) = 0                 ' A/D conversion start channel
320 PARAM%(16) = 0                 ' A/D conversion stop channel
330 PARAM%(17) = 0                 ' Overall gain code, 0 : +/- 5V
340 ' param%(45) : Error Code
350 ' param%(46) : Return Value 0
360 ' param%(47) : Return Value 1
370 '
380 FUN% = 3                       ' FUNCTION 3
390 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
400 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
410 '
420 FUN% = 4                       ' FUNCTION 4
430 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 4 : A/D initialization
440 IF PARAM%(45) <> 0 THEN PRINT "A/D INITIALIZATION FAILED !": STOP
450 '
460 FUN% = 5                       ' FUNCTION 5
470 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 5 :"N" times of A/D trigger
480                                    '
490 IF PARAM%(45) <> 0 THEN PRINT "A/D SOFTWARE DATA TRANSFER FAILED !": STOP
500 '
510 FOR I = 0 TO PARAM%(14) - 1    ' Display data
520 PRINT USING "DATA[ ### ] = ##.## V "; I, (10! * DAT%(I) / 4096! + (-5!))
530 ' 10      : A/D input range (-5V to 5V) => 10 = 5 - (-5)
540 ' DAT%(I) : A/D input data
550 ' 4096    : Full scale 12 bit A/D data
560 ' (-5)    : A/D input range "-5" V
570 NEXT I
580 END

