10 '**********************************************************************
20 '*  Program     : DIGIN.BAS                                           *
30 '*  Description : Demo program for PCM-3718 digital input             *
40 '*  Revision    : 1.00                                                *
50 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
60 '**********************************************************************
70 DIM PARAM%(60)                 ' If two boards installed, need to declare
80                                ' the second parameter array
90 DIM DAT%(100)                  ' Digital input data buffer
100 '
110 PARAM%(0) = 0                  ' Board number
120 PARAM%(1) = &H300              ' Base I/O address
130 PARAM%(5) = 50                 ' Pacer rate = 1M / (50 * 100) = 200 Hz
140 PARAM%(6) = 100                '
150 PARAM%(27) = VARPTR(DAT%(0))   ' Offset of digital input data buffer A
160 PARAM%(28) = VARSEG(DAT%(0))   ' Segment of digital input data buffer A
170 PARAM%(29) = 0                 ' Data buffer B address, if not used,
180 PARAM%(30) = 0                 ' must set to 0.
190 '
200 ' If your BASICA does not support VARSEG() function, you can put 0
210 ' to PARAM%(28), it means to use current data segment.
220 ' If you want to use the absolute memory address, please follow the steps.
230 ' PARAM%(27) = 0               ' Make sure 7000:0 is empty.
240 ' PARAM%(28) = &H7000
250 ' DEF SEG = &H7000             ' Define segment
260 ' After data conversion finished then use PEEK function to transfer data.
270 '
280 PARAM%(31) = 50                ' Digital input number
290 PARAM%(32) = 0                 ' Digital input port
300 ' PARAM%(45) : Error Code
310 ' PARAM%(46) : Return Value 0
320 ' PARAM%(47) : Return Value 1
330 '
340 FUN% = 3                       ' FUNCTION 3
350 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
360 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
370 '
380 FUN% = 20                      ' FUNCTION 20
390 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 20 : Digital input initialization
400 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL INPUT INITIALIZATION FAILED !": STOP
410 '
420 FUN% = 21                      ' FUNCTION 21
430 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 21 : "N" times of Digital input
440 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL INPUT FAILED !": STOP
450 PRINT
460 FOR I = 0 TO PARAM%(31) \ 2 - 1  ' Display data
470 PRINT "DATA["; I * 2; "] = ", (DAT%(I) AND &HFF);
480 IF DAT%(I) < 0 THEN PRINT "DATA["; I * 2 + 1; "]=";(65535! + DAT%(I)) \ 256,
490 IF DAT%(I) >= 0 THEN PRINT "DATA["; I * 2 + 1; "]="; DAT%(I) \ 256,
500 NEXT I
510 END
