10 '**********************************************************************
20 '*  Program     : DIGOUT.BAS                                          *
30 '*  Description : Demo program for PCM-3718 digital output            *
40 '*  Revision    : 1.00                                                *
50 '*  Date        : 5/16/1994                     Advantech Co., Ltd.   *
60 '**********************************************************************
70 DIM PARAM%(60)                 ' If two boards installed, need to declare
80                                ' the second parameter array
90 DIM DAT%(100)                  ' Digital output data buffer
100 '
110 PARAM%(0) = 0                  ' Board number
120 PARAM%(1) = &H300              ' Base I/O address
130 PARAM%(33) = VARPTR(DAT%(0))   ' Offset of digital output data buffer A
140 PARAM%(34) = VARSEG(DAT%(0))   ' Segment of digital output data buffer A
150 PARAM%(35) = 0                 ' Data buffer B address, if not used,
160 PARAM%(36) = 0                 ' must set to 0.
170 '
180 ' If your BASICA does not support VARSEG() function, you can put 0
190 ' to PARAM%(34), it means to use current data segment.
200 ' If you want to use the absolute memory address, please follow the steps.
210 ' PARAM%(33) = 0               ' Make sure 7000:0 is empty.
220 ' PARAM%(34) = &H7000
230 ' DEF SEG = &H7000             ' Define segment
240 PARAM%(37) = 1                 ' Digital output number
250 PARAM%(38) = 0                 ' Digital output port
260 ' PARAM%(45) : Error Code
270 ' PARAM%(46) : Return Value 0
280 ' PARAM%(47) : Return Value 1
290 '
300 FUN% = 3                       ' FUNCTION 3
310 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 3 : Hardware initialization
320 IF PARAM%(45) <> 0 THEN PRINT "DRIVER INITIALIZATION FAILED !": STOP
330 '
340 FUN% = 28                      ' FUNCTION 28
350 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 28 : Digital output initialization
360 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL OUTPUT INITIALIZATION FAILED !": STOP
370 '
380 INPUT "ENTER DIGITAL OUTPUT DATA (0-255) : "; DAT%(0)
390 '
400 FUN% = 29                      ' FUNCTION 29
410 CALL PCM3718(FUN%, SEG PARAM%(0))   ' Func 29 : "N" times of digital output
420 IF PARAM%(45) <> 0 THEN PRINT "DIGITAL OUTPUT FAILED !": STOP
430 '
440 END

