/*
     **********************************************************************
     *  Program     : ADDMA.C                                             *
     *  Description : Demo program for PCM-3718 pacer trigger A/D         *
     *                conversion with DMA data transfer.                  *
     *  Revision    : 1.00                                                *
     *  Date        : 5/16/1994                     Advantech Co., Ltd.   *
     **********************************************************************
*/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

extern pcm3718(int, unsigned int *);
unsigned int param[60];       /* If two boards installed, need to declare
				 the second parameter array                */
unsigned int data[100];       /* Conversion data buffer                    */
unsigned int far * dat;
main()
{
unsigned int i;
float        DataBuf;

       dat = data;
       clrscr();
       param[0]  = 0;            /* Board number                           */
       param[1]  = 0x300;        /* Base I/O address                       */
       param[2]  = 3;            /* Buffer A DMA channel                   */
       param[4]  = 2;            /* IRQ level   : IRQ2                     */
       param[5]  = 50;           /* Pacer rate = 1M / (50 * 100) = 200 Hz  */
       param[6]  = 100;
       param[7]  = 0;            /* Trigger mode, 0 : pacer trigger        */
       param[8]  = 0;            /* Non-cyclic                             */
       param[10] = FP_OFF(dat);  /* Offset of A/D data buffer A            */
       param[11] = FP_SEG(dat);  /* Segment of A/D data buffer A           */
       param[12] = 0;            /* Data buffer B address, if not used,    */
       param[13] = 0;            /* must set to 0.                         */
       param[14] = 50;           /* A/D conversion number                  */
       param[15] = 0;            /* A/D conversion start channel           */
       param[16] = 0;            /* A/D conversion stop channel            */
       param[17] = 0;            /* Overall gain code, 0 : +/- 5V          */

       /* param[18] = FP_OFF(gain_array);
          param[19] = FP_SEG(gain_array);  */

       /* param[45] : Error code
	  param[46] : Return value 0
          param[47] : Return value 1 */

       pcm3718(3, param);         /* Func 3 : Hardware initialization       */
       if (param[45] != 0) {
            printf("\nDRIVER INITIALIZATION FAILED !");
            exit(1);
            }

       pcm3718(4, param);         /* Func 4 : A/D initialization            */
       if (param[45] != 0) {
            printf("\nA/D INITIALIZATION FAILED !");
	    exit(1);
            }

       pcm3718(6, param);         /* Func 6 : Pacer trigger A/D conversion */
       if (param[45] != 0) {     /*          with DMA data transfer       */
            printf("\nA/D PACER TRIGGER WITH DMA DATA TRANSFER FAILED !");
	    exit(1);
	    }
       do {
	    pcm3718(7, param);             /* Func 7 : Check DMA status */
       }while((param[46] & 1) != 0);      /* 0 : not active, 1 : active      */

       for (i = 0; i < param[14]; i++)    /* Display data                    */
	 {
	    DataBuf = data[i] >> 4;
            /*
	       Because of the data format, shift right 4 bits to get
	       real value.  The data in low nybble is A/D channel
	       number from which this data converted.
	    */
	    DataBuf =( (5 - (-5)) * DataBuf / 4096) + (-5);
	    /*
	       (5 - (-5)) : A/D input range (-5V  to  5V)
	       4096       : Full scale 12 bit A/D data
	       DataBuf    : A/D input data
	       (-5)       : A/D input range "-5" V
	    */
	    printf("\ndata[%3d] = % 1.2f V ", i, DataBuf);

	  }
}
