/*
     **********************************************************************
     *  Program     : DIGIN.C                                             *
     *  Description : Demo program for PCM-3718 digital input             *
     *  Revision    : 1.00                                                *
     *  Date        : 5/16/1994                     Advantech Co., Ltd.   *
     **********************************************************************
*/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

extern pcm3718(int, unsigned int *);
unsigned int param[60];       /* If two boards installed, need to declare
                                 the second parameter array                */
unsigned char data[100];      /* Digital input data buffer                 */
unsigned char far * dat;
main()
{
unsigned int i;
       dat = data;
       param[0] = 0;             /* Board number                           */
       param[1] = 0x300;         /* Base I/O address                       */
       param[5]  = 50;           /* Pacer rate = 1M / (50 * 100) = 200 Hz  */
       param[6]  = 100;
       param[27] = FP_OFF(dat);  /* Offset of digital input data buffer A  */
       param[28] = FP_SEG(dat);  /* Segment of digital input data buffer A */
       param[29] = 0;            /* Data buffer B address, if not used,    */
       param[30] = 0;            /* must set to 0.                         */
       param[31] = 50;           /* Digital input number                   */
       param[32] = 0;            /* Digital input port                     */
       /* param[45] : Error code
          param[46] : Return value 0
          param[47] : Return value 1 */

       pcm3718(3, param);        /* Func 3 : Hardware initialization       */
       if (param[45] != 0) {
            printf(" DRIVER INITIALIZATION FAILED !");
            exit(1);
            }

       pcm3718(20, param);       /* Func 20 : Digital input initialization */
       if (param[45] != 0) {
            printf(" DIGITAL INPUT INITIALIZATION FAILED !");
            exit(1);
            }

       pcm3718(21, param);       /* Func 21 : "N" times of Digital input   */
       if (param[45] != 0) {
            printf(" DIGITAL INPUT FAILED !");
            exit(1);
            }

       for (i = 0; i < param[31]; i++)       /* Display data               */
            printf("\ndata[%d] = %d", i, data[i]);
}
