/*
     **********************************************************************
     *  Program     : DIGOUT.C                                            *
     *  Description : Demo program for PCM-3718 digital output            *
     *  Revision    : 1.00                                                *
     *  Date        : 5/16/1994                     Advantech Co., Ltd.   *
     **********************************************************************
*/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

extern pcm3718(int, unsigned int *);
unsigned int param[60];       /* If two boards installed, need to declare
                                 the second parameter array                */
unsigned char data[100];      /* Digital output data buffer                */
unsigned char far * dat;
main()
{
       dat = data;
       param[0] = 0;             /* Board number                           */
       param[1] = 0x300;         /* Base I/O address                       */
       param[33] = FP_OFF(dat);  /* Offset of digital output data buffer A */
       param[34] = FP_SEG(dat);  /* Segment of digital output data buffer A */
       param[35] = 0;            /* Data buffer B address, if not used,    */
       param[36] = 0;            /* must set to 0.                         */
       param[37] = 1;            /* Digital output number                  */
       param[38] = 0;            /* Digital Output port                    */
       /* param[45] : Error code
          param[46] : Return value 0
          param[47] : Return value 1 */

       pcm3718(3, param);        /* Func 3 : Hardware initialization       */
       if (param[45] != 0) {
            printf(" DRIVER INITIALIZATION FAILED !");
            exit(1);
            }

       pcm3718(28, param);       /* Func 28 : Digital output initialization*/
       if (param[45] != 0) {
            printf(" DIGITAL OUTPUT INITIALIZATION FAILED !");
            exit(1);
            }

       printf("\nENTER DIGITAL OUTPUT DATA (00 - 255): ");
       scanf("%d",&data[0]);     /* Enter digital output data              */

       pcm3718(29, param);       /* Func 29 : "N" times of digital output  */
       if (param[45] != 0) {
            printf(" DIGITAL OUTPUT FAILED !");
            exit(1);
            }
}
