{
 **********************************************************************
 *  Program	: ADTHERM.PAS					      *
 *  Description : Demo program for PCLD-779 to use PCM-3718 pacer     *
 *		  trigger A/D conversion with software data transfer. *
 *  Revision	: 1.00						      *
 *  Date	: 5/16/1994			Advantech Co., Ltd.   *
 **********************************************************************
}
program  pcl;
uses	 crt;
var
   param : array[0..60] of word;  { If two boards installed, need to
				       declare the second parameter array }
   dat	 : array[0..100] of integer; { Conversion PCLD-779 A/D data buffer}
   cjc	 : array[0..100] of integer; { Conversion PCLD-779 CJC data buffer}
   func  : integer;
{$L 3718TPF}
{$F+}
procedure  pcm3718(func:integer;var param:word);external;

VAR
   i	 : integer;
   DataBuf : real;
   CjcBuf  : real;
BEGIN
       param[0] := 0;		  { Board number			  }
       param[1] := $300;	  { Base I/O address			  }
       param[5] := 1000;	  { Pacer rate = 1M / (1000 * 200) = 5 Hz }
       param[6] := 200;
       param[7] := 0;		  { Trigger mode, 0 : pacer trigger	  }
       param[10] := ofs(dat);	  { Offset of PCLD-779 A/D data buffer A  }
       param[11] := seg(dat);	  { Segment of PCLD-779 A/D data buffer A }
       param[12] := 0;		  { Data buffer B address, if not used,   }
       param[13] := 0;		  { must set to 0.			  }
       param[14] := 20; 	  { PCLD-779 A/D conversion number	  }
       param[15] := 0;		  { PCLD-779 conversion start channel	  }
       param[16] := 0;		  { PCLD-779 conversion stop channel	  }
       param[17] := 0;		  { PCM-3718's overall gain code,0:+/- 5V }
       { param[45] : Error code
	 param[46] : Return value 0
	 param[47] : Return value 1 }
       param[50] := 1;		  { 1 : PCLD-779 daughter board type	  }
       param[51] := 0;		  { 0 : SoftWare, 2 : Interrupt trigger   }
       param[52] := ofs(cjc);	  { Offset of PCLD-779 CJC data buffer	  }
       param[53] := seg(cjc);	  { Segment of PCLD-779 CJC data buffer   }

       func := 3;
       pcm3718(func, param[0]);	  { Func 3 : Hardware initialization	  }
       if (param[45] <> 0)
       then
	    BEGIN
	       writeln(' DRIVER INITIALIZATION FAILED !');
	       exit;
	    END;
       writeln('Please wait .......');

       func :=	96;
       pcm3718(func, param[0]);	  { Func  96 : A/D initialization	    }
       if (param[45] <> 0)
       then
	    BEGIN
	       writeln(' A/D INITIALIZATION FAILED !');
	       exit;
	    END;

       func := 97;
       pcm3718(func, param[0]);	  { Func 97 : "N" times of A/D trigger     }
       if (param[45] <> 0)
       then
	    BEGIN
	       writeln(' A/D SOFTWARE DATA TRANSFER FAILED !');
	       exit;
	    END;


       for i := 0 to (param[14] - 1) do  { Display data                   }
	 BEGIN
	    DataBuf := dat[i] AND $FFF;
	    DataBuf := ( (5 - (-5)) * DataBuf / 4096) + (-5);
	    {
	       (5 - (-5)) : A/D input range (-5V  to  5V)
	       4096       : Full scale 12 bit A/D data
	       DataBuf    : A/D input data
	       (-5)       : A/D input range "-5" V
	    }

	    CjcBuf  := cjc[0] AND $FFF;
	    CjcBuf := ( (5 - (-5)) * CjcBuf / 4096) + (-5);

            writeln('data[', i:3, '] = ', DataBuf: 2:2,'V  ',
                '    CJC : ', CjcBuf * 1000 / 24.4: 3:2,' C' );
	 END;

END.
