{
 **********************************************************************
 *  Program     : DIGOUT.PAS                                          *
 *  Description : Demo program for PCM-3718 digital output            *
 *  Revision    : 1.00                                                *
 *  Date        : 5/16/1994                     Advantech Co., Ltd.   *
 **********************************************************************
}
program  pcl;
uses     crt;
var
   param : array[0..60] of word;  { If two boards installed, need to
                                       declare the second parameter array }
   dat   : array[0..100] of byte;    { Digital output data buffer         }
   func  : integer;
{$L 3718TPF}
{$F+}
procedure  pcm3718(func:integer;var param:word);external;

VAR
   i     : integer;
BEGIN
       param[0] := 0;             { Board number                          }
       param[1] := $300;          { Base I/O address                      }
       param[33] := ofs(dat);     { Offset of digital output data buffer A  }
       param[34] := seg(dat);     { Segment of digital output data buffer A }
       param[35] := 0;            { Data buffer B address, if not used,   }
       param[36] := 0;            { must set to 0.                        }
       param[37] := 1;            { Digital output number                 }
       param[38] := 0;            { Digital output port                   }
       { param[45] : Error code
         param[46] : Return value 0
         param[47] : Return value 1 }

       func := 3;
       pcm3718(func, param[0]);   { Func 3 : Hardware initialization      }
       if (param[45] <> 0)
       then
            BEGIN
               writeln(' DRIVER INITIALIZATION FAILED !');
               exit;
            END;

       func := 28;
       pcm3718(func, param[0]);   { Func 28 : Digital output initialization }
       if (param[45] <> 0)
       then
            BEGIN
               writeln(' DIGITAL OUTPUT INITIALIZATION FAILED !');
               exit;
            END;

       writeln('ENTER DIGITAL OUTPUT DATA (0-255): ');
       read(dat[0]);              { Enter digital output data             }

       func := 29;
       pcm3718(func, param[0]);   { Func 29 : "N" times of digital output }
       if (param[45] <> 0)
       then
            BEGIN
               writeln(' DIGITAL OUTPUT FAILED !');
               exit;
            END;
END.
