#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <stdio.h>
#include <math.h>

/* key definition */
#define UPARR           0x4800
#define DNARR           0x5000
#define ESC             0x11b
#define RTARR           0x4d00
#define LTARR           0x4b00
#define PGUP            0x4900
#define PGDN            0x5100
#define HOME            0x4700
#define ENTER           0x1c0d
#define BACKSP          0x0e08
#define F1              0x3b00
#define F2              0x3c00
#define F10             0x4400

/* display area definition */
#define  ADLINE         8               /* A/D first display column */
#define  DALINE         27              /* D/A first display column */
#define  DAUNIT         34              /* D/A unit display column */
#define  DILINE1        47              /* DI first line display column */
#define  DILINE2        55              /* DI second line display column */
#define  DOLINE1        67              /* DO first line display column */
#define  DOLINE2        75              /* DO second line display column */

/* working parameter */
#define  ADSET          10              /* A/D setting type selection */
#define  DASET          11              /* programmable D/A range setting */
#define  INDIVIDUAL     13              /* progarmmable A/D range setting */
#define  DAEDIT         14              /* D/A editing operation */
#define  DOEDIT         15              /* D/O editing operation */

/* return parameter definition */
#define OK              55
#define FAIL            0xAA

#define ON              '1'
#define OFF             '0'

#define KNULL           -1

#define TRUE            0x50
#define FALSE           0x05

/* operation parameter */
#define TIMEOVER        1000            /* A/D trigger time out constant */


#define SETUP           1               /* setup window command */
#define RECOVER         2               /* erase window command */

#define TOTALCARD       18              /* available cards number */
#define PCL711          0               /* card code */
#define PCM3718         1
#define PCL812          2
#define PCL813          3
#define PCL818          4
#define PCL818H         5
#define PCL818HG        6
#define PCL818L         7
#define PCL812PG        8
#define PCL1800         9
#define PCL720          10
#define PCL721          11
#define PCL723          12
#define PCL725          13
#define PCL726          14
#define PCL727          15
#define PCL728          16
#define PCL860          17



#define TOTALMENU       6               /* selectable menu no. */
#define CARDTYPE        0               /* menu code */
#define ADDRESS         1
#define IRQ_LEVEL       2
#define AD_RANGE        3
#define DA_RANGE        4
#define EDIT            5

int     baseI=0x300;                    /* I/O base address */
int     ad_range_no=9;                  /* available A/D range no. */
int     da_range_no=2;                  /* available D/A range no. */
int     ad_range=0;                     /* current A/D range */
int     ad_gain[32];                    /* A/D range for programmable gain */
float   ad_value[32];                   /* A/D value */
unsigned int ad_word [32];              /* 16 bit A/D register             */
unsigned int da_word ;                  /* 16 bit D/A register             */
int     da_range=0;                     /* current D/A range */
int     da_gain[16];                    /* D/A range for programmable gain */
double  da_value[16];                   /* D/A value */
int     ad_no=16;                       /* available A/D channel no. */
int     da_no=2;                        /* available D/A channel no. */
int     di_no=16;                       /* available D/I channel no. */
char    di_value[32];                   /* D/I status */
int     do_no=16;                       /* available D/O channel no. */
char    do_value[32];                   /* D/O status */

int     dach=0;                         /* current D/A editing channel */
int     doch=0;                         /* current D/O editing channel */

int     boardI=PCL818H;                 /* current card type */

unsigned char irqI=7;                   /* interrupt level for PCL-721/723 */

int     menuI=CARDTYPE;                 /* current menu */

int     monochrome=ON;                  /* current monitor type */

int     edit_f=OFF;                     /* editing operation status */
int     editem=0;                       /* editing item */

int     vc_f=ON;                        /* display in voltage or count flag */
int     mvc_f[16]={OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF,OFF}; /* display mv unit ? */
int     ad_32=OFF;                      /* display AD Channel 16 to 32   */
int     iflag=OFF;                      /* interrupt flag */

void    interrupt (*old_handler)(); /* interrupt handler */
void    interrupt int_di(void);
int     int_status[4];

unsigned char old_irqI=7;

char    int_value[32];

char    vbuf[30][20][2];           /* video buffer for window process */
int     di_enable=1;               /* select digital input port of PCM-3718 */